#!/bin/bash

# Version 23/12/2011
# $Revision: 1.10 $
# UDA'Software 2010

# Questo script serve per convertire un file ini di mIRC in uno
# compatibile con BuDuScRiPt.

################################################################################
#_______________________________________________________________________________
usermenu_macro_path=${HOME}/.xchat2/buduscript/usermenu.mcr
lock_file=${HOME}/.xchat2/buduscript/usermenu.lck

append_flag=0

################################################################################
#_______________________________________________________________________________
check_overwrite() {
    if [ -f "${usermenu_macro_path}" ]; then
	clear
	cat<<EOF
********************************************************************************
*             PROCEDURA DI IMPORTAZIONE DI UN FILE INI DI mIRC                 *
********************************************************************************
 ATTENZIONE: File ${usermenu_macro_path} gia' presente !
********************************************************************************
 Il File MACRO  che carica il Menu Utente e' gia' presente, quindi e' necessario
scegliere se Sovrascriverlo, Accodare le informazioni che si stanno per
importare o Uscire dall'operazione.

 Notare che, se si sovrascrive la MACRO sbagliata, si puo' compromettere il
funzionamento di BuDuScRiPt o parti di esso; salvo non venga utilizzata
l'opzione di uscita, verra' comunque effettuato un backup del file originale.
********************************************************************************
Vuoi Sovrascrivere, Accodare o Uscire (S/a/u) ?
EOF
	[ ${flag_skip_user_question:-0} == 0 ] && read overwrite
	[ ${flag_skip_user_question:-0} == 1 ] && overwrite="u"
	if [ "${overwrite}" == "a" ] || [ "${overwrite}" == "A" ]; then
	    append_flag=1
	elif [ "${overwrite}" == "u" ] || [ "${overwrite}" == "U" ]; then
	    if [ -f "${lock_file}" ]; then rm -f "${lock_file}"; fi
	    exit 1;
	fi
	
	cp -vf "${usermenu_macro_path}" "${usermenu_macro_path}.$(date +%Y%m%d%H%M%S)"
    fi
}

################################################################################
#_______________________________________________________________________________
set_menu_level() {
    is_command=$(echo "${data}" | grep -F "_COMMAND_SEPARATOR_")
    menu_level=$(echo "${data}" \
	| sed s/[^\.]/_/g \
	| cut -f1 -d'_' \
	| wc -c)
    
    case "${menu_level}" in
	1)
	    menu_name_level_1="/${menu_name}"
	    active_menu_tree="${root_menu_name}"
	    active_menu_tree_level=1
	    ;;
	2)
	    menu_name_level_2="/${menu_name}"
	    active_menu_tree="${root_menu_name}${menu_name_level_1}"
	    active_menu_tree_level=2
	    ;;
	3)
	    menu_name_level_3="/${menu_name}"
	    active_menu_tree="${root_menu_name}${menu_name_level_1}${menu_name_level_2}"
	    active_menu_tree_level=3
	    ;;
	4)
	    menu_name_level_4="/${menu_name}"
	    active_menu_tree="${root_menu_name}${menu_name_level_1}${menu_name_level_2}${menu_name_level_3}"
	    active_menu_tree_level=4
	    ;;
	5)
	    menu_name_level_5="/${menu_name}"
	    active_menu_tree="${root_menu_name}${menu_name_level_1}${menu_name_level_2}${menu_name_level_3}${menu_name_level_4}"
	    active_menu_tree_level=5
	    ;;
	6)
	    menu_name_level_6="/${menu_name}"
	    active_menu_tree="${root_menu_name}${menu_name_level_1}${menu_name_level_2}${menu_name_level_3}${menu_name_level_4}${menu_name_level_5}"
	    active_menu_tree_level=6
	    ;;
	7)
	    menu_name_level_7="/${menu_name}"
	    active_menu_tree="${root_menu_name}${menu_name_level_1}${menu_name_level_2}${menu_name_level_3}${menu_name_level_4}${menu_name_level_5}${menu_name_level_6}"
	    active_menu_tree_level=7
	    ;;
	8)
	    menu_name_level_8="/${menu_name}"
	    active_menu_tree="${root_menu_name}${menu_name_level_1}${menu_name_level_2}${menu_name_level_3}${menu_name_level_4}${menu_name_level_5}${menu_name_level_6}${menu_name_level_7}"
	    active_menu_tree_level=8
	    ;;
	9)
	    menu_name_level_9="/${menu_name}"
	    active_menu_tree="${root_menu_name}${menu_name_level_1}${menu_name_level_2}${menu_name_level_3}${menu_name_level_4}${menu_name_level_5}${menu_name_level_6}${menu_name_level_7}${menu_name_level_8}"
	    active_menu_tree_level=9
	    ;;
	*)
	    if [ "${is_command}" != "" ]; then
		printf "Cmd.: %$(expr 60 - ${menu_level})s %${menu_level}s SCARTATO\n" "${menu_name_command}" "-"
	    else
		printf "Menu: %$(expr 60 - ${menu_level})s %${menu_level}s SCARTATO\n" "${menu_name}" "-"
	    fi
	    echo "(Livello ${menu_level} fuori dal limite massimo: 9)"
	    
	    active_menu_tree_level=0
	    error_status=1
	    ;;
    esac
}

################################################################################
#_______________________________________________________________________________
if [ "${1}" == "AUTOCHECK" ]; then
    if [ ! -f "${lock_file}" ]; then
	echo "/budus macro usermenu"
	echo "/ECHO %C3,1PROCEDURA DI IMPORTAZIONE DEL FILE INI mIRC TERMINATA."
    else
	echo "/TIMER -refnum 2255 5 budus pipe_script_silent \"${HOME}/.xchat2/buduscript/buduscript_script__import_mirc_ini.sh\" AUTOCHECK"
    fi
    
    exit 0;
fi

################################################################################
#_______________________________________________________________________________
if [ "${1}" == "AUTORUN" ]; then
    if [ -f "${lock_file}" ]; then
	echo "/ECHO %C4,1ERRORE: Sembra che la procedura di importazione sia ancora attiva, oppure, non sia terminata correttamente."
	echo "/ECHO %C8,1Se non e' terminata correttamente, si puo' risolvere il problema eliminando il file con il comando: %C3,1%B/exec rm -f ${lock_file}"
	
	exit 1;
    fi
    touch "${lock_file}"
    if [ ! -f "${lock_file}" ]; then
	echo "/ECHO %C4,1ERRORE: Impossibile lanciare la procedura di AUTORUN, probabile problema di permessi."
	
	exit 1;
    fi
    echo "/TIMER -refnum 2255 5 budus pipe_script_silent \"${HOME}/.xchat2/buduscript/buduscript_script__import_mirc_ini.sh\" AUTOCHECK"
    echo "/exec xterm -e \"${HOME}/.xchat2/buduscript/buduscript_script__import_mirc_ini.sh\" SCRIPT"
    
    exit 0;
fi

################################################################################
#_______________________________________________________________________________
# ########## ########## ########## ########## ########## ########## ##########
# ########## ########## ##########   INIZIO   ########## ########## ##########
# ########## ########## ########## ########## ########## ########## ##########

if [ "${1}" != "SCRIPT" ]; then
    file_ini_path=${1}
    root_menu_name=${2}
    
    if [ "${file_ini_path}" == "" ] || [ "${root_menu_name}" == "" ]; then
	echo "ERRORE  : Sintassi errata, non hai specificato il file INI mIRC da importare e/o il nome del Menu."
	echo "SINTASSI: mircini_to_buduscript.sh <inifile> <menuname> [fileout]"
	echo "ESEMPIO : mircini_to_buduscript.sh mirc.ini Personale"
	
	if [ -f "${lock_file}" ]; then rm -f "${lock_file}"; fi
	exit 1;
    fi
    
    if [ ! -f "${file_ini_path}" ]; then
	echo "ERRORE  : File ${file_ini_path} non trovato."
	
	if [ -f "${lock_file}" ]; then rm -f "${lock_file}"; fi
	exit 1;
    fi

    if [ "${file_ini_path/*.gz/1}" == "1" ]; then
	uncompress_flag=1
    else
	uncompress_flag=0
    fi

    if [ "${3}" != "" ]; then
	usermenu_macro_path=${3}
    fi
    
    usermenu_macro_name=$(basename "${usermenu_macro_path/.mcr/}")

    if [ "${4}" == "AUTO" ]; then
	flag_skip_user_question=1
    fi
    
    check_overwrite
else
    clear
    cat<<EOF
********************************************************************************
*             PROCEDURA DI IMPORTAZIONE DI UN FILE INI DI mIRC                 *
********************************************************************************
 Questa procedura automatica ha il compito di tradurre quante piu' informazioni
possibili da un file .ini del mIRC (famoso IRC Client per Windows) in un formato
compatibile con BuDuScRiPt/XChat .
 Cio' consente di creare un "Menu Utente" (il cui nome verra' chiesto di
seguito) contenente quanti piu' comandi possibile estrapolati, appunto, dal
file INI.
 Chiaramente la quantita' di informazioni convertite dipende molto dalla
compatibilita' delle stesse con XChat, ad esempio non e' possibile importare
quei comandi che fanno uso di script interni (veri e propri micro-programmi),
ma tutte quelle funzioni che utilizzano comandi IRC standard (SAY, ME, ad
esempio) sono facilmente convertibili. Sono supportati anche i comandi a tempo e
addirittura anche le "domande" (cioe' l'immissione di input da parte
dell'utente, in un'apposita finestra che appare quando cio' e' richiesto).
 Affinche' la procedura funzioni e' necessario che nella HOME directory
dell'utente (${HOME}) o in quella di BuDuScRiPt (.xchat2/buduscript) sia
presente un file con estensione .ini o .ini.gz .
 Il file scelto verra' importato e andra' a sovrascrivere/accodarsi al file
${HOME}/.xchat2/buduscript/usermenu.mcr .
********************************************************************************
PREMI INVIO PER CONTINUARE ...
EOF
    read

    # Verifica se nella home sono presenti dei files ini
    exist_ini_files=$(find ${HOME}/ -maxdepth 1 -name '*.ini')
    exist_ini_gz_files=$(find ${HOME}/ -maxdepth 1 -name '*.ini.gz')

    if [ "${exist_ini_files}" == "" ] && [ "${exist_ini_gz_files}" == "" ]; then
	file_ini_path="${HOME}/.xchat2/buduscript/mirc.ini"
	
	if [ ! -f "${file_ini_path}" ] && [ ! -f "${file_ini_path}.gz" ]; then
	    file_ini_path="${HOME}/mirc.ini"
	    if [ ! -f "${file_ini_path}" ] && [ ! -f "${file_ini_path}.gz" ]; then
		echo "ERRORE  : File ${file_ini_path} non trovato, controllare anche minuscole/MAIUSCOLE."
		echo "Premere INVIO."
		read
		
		if [ -f "${lock_file}" ]; then rm -f "${lock_file}"; fi
		exit 1;
	    fi
	    
	    if [ ! -f "${file_ini_path}" ] && [ -f "${file_ini_path}.gz" ]; then
		file_ini_path="${HOME}/mirc.ini.gz"
		uncompress_flag=1
	    else
		uncompress_flag=0
	    fi
	else
	    if [ ! -f "${file_ini_path}" ] && [ -f "${file_ini_path}.gz" ]; then
		file_ini_path="${HOME}/.xchat2/buduscript/mirc.ini.gz"
		uncompress_flag=1
	    else
		uncompress_flag=0
	    fi	
	fi
    else
	ini_files_list=$(printf "Esci\n%s\n%s\n" "${exist_ini_files}" "${exist_ini_gz_files}")
	if [ "${ini_files_list}" != "" ]; then
	    clear
	    printf "Digita il numero corrispondente al file .INI che desideri importare\ne premi INVIO:\n"
	    
	    select file_ini_path in ${ini_files_list}; do
		if [ "${file_ini_path}" == "Esci" ]; then
		    if [ -f "${lock_file}" ]; then rm -f "${lock_file}"; fi
		    
		    exit 0;
		fi
		
		if [ "$(echo "${file_ini_path}" | grep -i '\.ini\.gz$')" != "" ]; then
		    uncompress_flag=1
		else
		    uncompress_flag=0
		fi
		
		break;
	    done
	else
	    echo "ERRORE  : Nessun file INI trovato nella HOME directory."
	    echo "Premere INVIO."
	    read
	    
	    if [ -f "${lock_file}" ]; then rm -f "${lock_file}"; fi
	    exit 1;
	fi
    fi
    
    if [ "$(echo ${LANG} | grep -iF "UTF-8")" != "" ]; then
	clear
	cat<<EOF
********************************************************************************
*             PROCEDURA DI IMPORTAZIONE DI UN FILE INI DI mIRC                 *
********************************************************************************
*                                ATTENZIONE                                    *
********************************************************************************
 La codifica caratteri attualmente utilizzata da questo sistema operativo, 
risulta essere ${LANG} .

 E' possibile che, se il file .INI che si cerca di importare, contiene caratteri
NON ASCII, possano verificarsi problemi tali da causare il pressoche' totale
fallimento della conversione (da menu vuoti fino a comandi malfunzionanti).

 Per risolvere il problema puo' essere necessario utilizzare un tool di
conversione che si preoccupi di tradurre opportunamente i caratteri non ASCII
eventualmente presenti nel file mirc.ini .

 Questa procedura ti consente, se il tuo Sistema Operativo e' abilitato, di
effettuare la conversione in modo automatico, ma chiaramente cio' andra' a buon
fine solo se il file INI e' codificato secondo iso-8859-1 e nel sistema e'
disponibile la codifica utf-8 .
********************************************************************************
PREMI INVIO PER CONTINUARE ...
EOF
	read
    fi
    
    clear
    cat<<EOF
********************************************************************************
*             PROCEDURA DI IMPORTAZIONE DI UN FILE INI DI mIRC                 *
********************************************************************************
 Come prima cosa bisogna stabilire il NOME del Menu che si vuole aggiungere ad
XChat e che verra' aggiunto a quelli gia' esistenti (XChat, View, Server, ecc.)

 E' possibile usare solo lettere e numeri e sarebbe opportuno non fosse troppo
lungo; se si preme INVIO, verra' accettato il valore di default:  Menu Utente
********************************************************************************
Inserire il nome del Menu Utente che si vuole aggiungere: 
EOF
    read root_menu_name
    root_menu_name=$(echo "${root_menu_name}" | sed s/[^0-9a-zA-Z]//g)
    if [ "${root_menu_name}" == "" ]; then
	root_menu_name="_Menu Utente"
    fi

    check_overwrite    
    clear
fi

IFS_OLD=${IFS}
IFS=$'\n'

iconv_found=0
if [ "$(iconv --version)" != "" ]; then
    clear
    cat<<EOF
********************************************************************************
*             PROCEDURA DI IMPORTAZIONE DI UN FILE INI DI mIRC                 *
********************************************************************************
*                                ATTENZIONE                                    *
********************************************************************************
 Affinche' sia possibile visualizzare correttamente messaggi contenenti
caratteri NON ASCII (cioe' non appartenenti a numeri, lettere o simboli di
punteggiatura, ad esempio quelli usati nelle " Decorazioni") puo' essere
opportuno convertire il file INI che si sta importando dal set di caratteri
iso-8859-1 (normalmente viene usato questo, se cosi' non fosse rispondere N)
a quello Unicode UTF-8.
 XChat, nella "Network List ..." (cioe' dove si configurano gli IRC servers a
cui collegarsi) consente, nel menu "Modifica", di impostare il "Set di
Caratteri" e, normalmente, andrebbe usato UTF-8 salvo diversamente richiesto
dal Server.
 Sostanzialmente, affinche' tutti i caratteri vengano rappresentati
correttamente, e' necessario che sia il file INI che XChat utilizzino il
medesimo set di caratteri. Se non si e' sicuri, si puo' rispondere N e
verificare se i comandi importanti funzionano correttamente e che l'output sia
sempre "leggibile", viceversa, si puo' riprovare effettuando la conversione.
********************************************************************************
 Vuoi procedere alla conversione automatica dal set di caratteri iso-8859-1 a
quello Unicode utf-8 (s/N) ?
EOF
    [ ${flag_skip_user_question:-0} == 0 ] && read unicode
    [ ${flag_skip_user_question:-0} == 1 ] && unicode="n"
    if [ "${unicode}" == "s" ] || [ "${unicode}" == "S" ]; then
	iconv_found=1
    fi
fi

if [ ${iconv_found} == 1 ]; then
    if [ ${uncompress_flag} == 1 ]; then
	mircini_data=$(zcat "${file_ini_path}" | iconv -f iso-8859-1 -t utf-8)
    else
	mircini_data=$(iconv -f iso-8859-1 -t utf-8 "${file_ini_path}")
    fi
else
    if [ ${uncompress_flag} == 1 ]; then
	mircini_data=$(zcat "${file_ini_path}")
    else
	mircini_data=$(cat "${file_ini_path}")
    fi
fi

mircini_imported_data=$(
    echo "${mircini_data}" \
	| sed 's/^n[0-9]*=[ ]*//' \
	| sed 's/^[ ]*//' \
	| tr '\r' '' \
	| tr '\233' '' \
	| sed 's/^[ ]*[ ]*/++Menu /' \
	| sed 's/$//' \
	| sed 's/[ ]*$//' \
	| grep "\(^\.\|.*{.*}$\|++Menu\ \)" \
	| sed 's/^++Menu //' \
	| grep -v -e "\(set\|var\)[ ]\+%" -e "%[a-zA-Z0-9\._]*$" -e "^[iI][fF]" -e "^[aA][lL][iI][aA][sS]" \
	| sed s@\"@_VIRGOLETTE_@g \
	| sed s@\'@_VIRGOLETTA_@g \
	| sed s@\\\([\ ]*:[\ ]*\\\|[\ ]\\\{1,\\\}{[\ ]*\\\)@_COMMAND_SEPARATOR_@ \
	| sed 's[ ]*}$' \
	| sed s@[\$]\\\{1,\\\}[0-9]\\\{1,\\\}@%s@g \
	| sed s@[\$]*\$\?[*]*=@\$\$\?=@g \
	| sed s/\$\ \$+/%s/g \
	| sed s@\$me@\$nick\ @g \
	| sed s@\$nickname@\$nick\ @g \
	| sed s@\$null@echo\ NULL@g \
	| sed s@\\\(\$chan\\\|#mychan\\\)@%c@g \
	| sed 's@ \+#\( \+\|$\)@ %c @g' \
	| sed 's@/[rR][uU][nN] @/exec @' \
	| sed 's@[eE][xX][pP][lL][oO][rR][eE][rR]\.[eE][xX][eE] @xdg-open @'
)

if [ ${uncompress_flag} == 1 ]; then
    original_mircini_line=$(zcat "${file_ini_path}" | wc -l)
else
    original_mircini_line=$(cat "${file_ini_path}" | wc -l)
fi
imported_mircini_line=$(echo "${mircini_imported_data}" | wc -l)

if [ ${imported_mircini_line} -gt ${original_mircini_line} ]; then
    imported_mircini_line=${original_mircini_line}
fi

printf "Su ${original_mircini_line} linee ne verranno importante circa ${imported_mircini_line}, cioe' l'%s%%.\n" "$(expr ${imported_mircini_line} \* 100 / ${original_mircini_line})"

if [ $(expr ${imported_mircini_line} \* 100 / ${original_mircini_line}) -lt 5 ]; then
    echo "ATTENZIONE: Sembra che del file ini specificato poco o nulla sara' importato."
    echo "E' probabile si tratti di un file totalmente incompatibile, devo abortire qui."
    [ ${flag_skip_user_question:-0} == 0 ] && echo "Premi INVIO."
    [ ${flag_skip_user_question:-0} == 0 ] && read
    
    if [ -f "${lock_file}" ]; then rm -f "${lock_file}"; fi
    exit 1;
fi

################################################################################
#_______________________________________________________________________________
echo "Scrittura dell'HEADER per il menu ${root_menu_name}"

if [ ${append_flag} == 1 ]; then
    echo "# Append Imported mIRC INI File at $(date)" >> ${usermenu_macro_path}
else
    echo "#nolist" > ${usermenu_macro_path}
    echo "#fastflush" >> ${usermenu_macro_path}
    echo "#budusmenu" >> ${usermenu_macro_path}
fi

cat<<EOF >> ${usermenu_macro_path}
# ******************************************************************************
# File MACRO importato dal file dati mIRC: ${file_ini_path}
# By UDA'Software 2011 - Versione $Revision: 1.10 $
# ******************************************************************************
EOF
echo "/MENU DEL \"${root_menu_name}\"" >> ${usermenu_macro_path}
echo "/MENU ADD \"${root_menu_name}\"" >> ${usermenu_macro_path}
if [ ${append_flag} == 0 ]; then
    macro_menu_name=$(echo "${usermenu_macro_path}" | sed s@.*/@@ | sed s/\\\.mcr//)
    echo "/MENU ADD \"${root_menu_name}/_Ricarica Menu ${root_menu_name}\" \"budus macro ${macro_menu_name}\"" >> ${usermenu_macro_path}
    echo "/MENU ADD \"${root_menu_name}/-\"" >> ${usermenu_macro_path}
fi

last_menu_name="${root_menu_name}"
last_menu_item="${root_menu_name}"
previous_menu_level=1
previous_separator_level=1
total_line=0
total_line_imported=0
for data in ${mircini_imported_data}; do
    total_line=$((${total_line} + 1))
    error_status=0
    
    if [ "$(echo "${data}" | grep -F "_COMMAND_SEPARATOR_")" == "" ]; then
	menu_name=$(echo "${data}" \
	    | sed s/_VIRGOLETTE_//g \
	    | sed s/_VIRGOLETTA_/\'/g \
	    | cut -f1- -d' ' \
	    | sed s/^[\.]*// \
	    | sed s/\\\(^[\ \*]*\\\|[\ {]*$\\\)//g \
	    | sed s/\\\(^[\ \*]*\\\|[\ {]*$\\\)//g \
	    | sed s/^[-]\\\{2,\\\}// \
	    | sed s@/@@g \
	    | cut -b-50 \
	    | tr '&' '_')
	
	if [ "${menu_name}" == "" ]; then
	    menu_name="Menu $RANDOM"
	fi
	
	if [ "${menu_name/ */}" == "_BUDUSCRIPT_MENU_INIT_COMMAND_" ]; then
	    printf "Importazione del comando di inizializzazione.\n"
	    
	    initializing_command="${data/._BUDUSCRIPT_MENU_INIT_COMMAND_ /}"
	    
	    cat<<EOF >> ${usermenu_macro_path}
# ******************************************************************************
# COMANDO DI INIZIALIZZAZIONE A CARICAMENTO IMMEDIATO:
${initializing_command}
EOF
	elif [ "${menu_name}" != "${last_menu_name}" ] || [ ${previous_menu_level} != ${menu_level} ]; then
	    last_menu_name="${menu_name}"
	    set_menu_level

	    if [ "${menu_name}" == "-" ]; then
		if [ ${menu_level} != ${previous_separator_level} ]; then
		    total_line_imported=$((${total_line_imported} + 1))
		    
		    if [ "${active_menu_tree}" == "" ]; then
			echo "/MENU ADD \"${root_menu_name}/-\"" >> ${usermenu_macro_path}
		    else
			echo "/MENU ADD \"${active_menu_tree}/-\"" >> ${usermenu_macro_path}
		    fi
		    previous_separator_level=${menu_level}
		else
		    printf "Menu: %$(expr 60 - ${menu_level})s %${menu_level}s SCARTATO\n" "SEPARATORE" "-"
		    echo "(Livello separatore ${menu_level} uguale a quello precedente)"
		fi
	    else
		if [ ${menu_level} -gt $((${previous_menu_level} + 1)) ]; then
		    printf "Menu: %$(expr 60 - ${menu_level})s %${menu_level}s SCARTATO\n" "${menu_name}" "-"
		    echo "(Livello ${menu_level} superiore a quello massimo: ${previous_menu_level})"
		    error_status=2
		elif [ "$(grep -F "/MENU ADD \"${active_menu_tree}/${menu_name}\"" "${usermenu_macro_path}")" != "" ]; then
		    printf "Menu: %$(expr 60 - ${menu_level})s %${menu_level}s SCARTATO\n" "${menu_name}" "-"
		    echo "(Menu gia' presente)"
		    error_status=3
		fi
		
		if [ ${error_status} == 0 ]; then
		    total_line_imported=$((${total_line_imported} + 1))
		    if [ ${menu_level} == ${previous_separator_level} ]; then
			previous_separator_level=0
		    fi
		    previous_menu_level=${menu_level}
		    
		    printf "Menu: %$(expr 60 - ${menu_level})s %${menu_level}s IMPORTATO\n" "${menu_name}" "+"
		    
		    cat<<EOF >> ${usermenu_macro_path}
# ******************************************************************************
# SEZIONE di livello ${menu_level}: ${menu_name}
# ******************************************************************************
EOF
		    echo "/MENU ADD \"${active_menu_tree}/${menu_name}\"" >> ${usermenu_macro_path}
		    last_menu_item="${active_menu_tree}/${menu_name}"
		fi
	    fi
	else
	    printf "Menu: %$(expr 60 - ${menu_level})s %${menu_level}s SCARTATO\n" "${menu_name}" "-"
	    echo "(Menu o Separatore ripetuto)"
	fi
    else
	set_menu_level
	
	menu_name_command=$(echo "${data}" \
	    | sed s/_COMMAND_SEPARATOR_.*// \
	    | sed s/_VIRGOLETTE_//g \
	    | sed s/_VIRGOLETTA_/\'/g \
	    | cut -f1- -d' ' \
	    | sed s/^[\.]*// \
	    | sed s/\\\(^[/\ \*]*\\\|[\ {]*$\\\)//g \
	    | sed s/\\\(^[/\ \*]*\\\|[\ {]*$\\\)//g \
	    | cut -b-50 \
	    | sed s/^[-]*//g \
	    | tr '&' '_')
			
	command_data=$(echo "${data}" \
	    | sed s/.*_COMMAND_SEPARATOR_//)
	    
	if [ "$(grep -F "/MENU ADD \"${active_menu_tree}/${menu_name_command}\"" "${usermenu_macro_path}")" == "" ] && \
	    [ ${menu_level} -le $((${previous_menu_level} + 1)) ]; then
	    total_line_imported=$((${total_line_imported} + 1))
	    last_menu_name="${menu_name_command}"
	    if [ ${menu_level} == ${previous_separator_level} ]; then
		previous_separator_level=0
	    fi
	    
	    printf "/MENU ADD \"%s\"" "${active_menu_tree}/${menu_name_command}" >> ${usermenu_macro_path}
	    if [ "$(echo "${command_data}" | grep -F -e " | " -e "_VIRGOLETTA_" -e "_VIRGOLETTE_" -e '$$?=' -e "\$nick" -e "\$server" -e "\$network")" != "" ]; then
		command_data="budus macro MC $(echo "${command_data}" | sed s/^[\ ]*{[\ ]*//)"
	    else
		command_data=$(echo "${command_data}" | sed s@^/@@)
	    fi
	    
	    printf " \"%s\"\n" "${command_data}" >> ${usermenu_macro_path}
	else
	    printf "Cmd.: %$(expr 60 - ${menu_level})s %${menu_level}s SCARTATO\n" "${menu_name_command}" "-"
	    if [ ${menu_level} -le $((${previous_menu_level} + 1)) ]; then
		echo "(Comando gia' presente nel menu)"
	    else
		echo "(Livello comando ${menu_level} superiore a quello ammesso: $((${previous_menu_level} + 1)))"
	    fi
	fi
    fi
done

echo "Fine Importazione, premi INVIO per continuare o [Shift]+[PagUp] per controllare."
[ ${flag_skip_user_question:-0} == 0 ] && read

################################################################################
#_______________________________________________________________________________
IFS=${IFS_OLD:-NULL}

if [ "${1}" == "SCRIPT" ] || [ ${flag_skip_user_question:-0} == 1 ]; then
    if [ -f "${lock_file}" ]; then rm -f "${lock_file}"; fi
    
    clear
    cat<<EOF
********************************************************************************
*             PROCEDURA DI IMPORTAZIONE DI UN FILE INI DI mIRC                 *
********************************************************************************
 Il menu importato e' stato convertito in una MACRO BuDuScRiPt; lanciando questa
MACRO viene aggiunto ad XChat il menu.

 Tuttavia la MACRO non viene lanciata in automatico all'avvio di BuDuScRiPt,
quindi, ora bisogna decidere se rendere permanente la cosa.
********************************************************************************
 Vuoi che il menu venga automaticamente caricato all'avvio di BuDuScRiPt (S/n) ?
EOF
    [ ${flag_skip_user_question:-0} == 0 ] && [ ${append_flag:-0} == 0 ] && read autoload
    [ ${flag_skip_user_question:-0} == 1 ] && autoload="s"
    if [ ${append_flag:-0} == 0 ] && [ "${autoload}" != "n" ] && [ "${autoload}" != "N" ]; then
	autoload_file="$HOME/.xchat2/buduscript/onload_user.mcr"
	if [ ! -f "${autoload_file}" ]; then
	    cat<<EOF > "${autoload_file}"
#fastflush
#budusmenu
EOF
	fi
	
	if [ "$(grep "/budus macro ${usermenu_macro_name}$" "${autoload_file}")" == "" ]; then
	    cat<<EOF >> "${autoload_file}"
# Caricamento del Menu ${root_menu_name}
/budus macro ${usermenu_macro_name}
EOF

	fi
    fi
    
    [ ${flag_skip_user_question:-0} == 1 ] && \
	printf 'Procedura di Importazione Menu Automatizzata terminata. Nuovo Menu caricato al prossimo avvio di XChat, oppure, caricarlo manualmente con il comando: /budus macro %s\n' "${usermenu_macro_name}" && \
	exit 0;
    
    clear
    cat<<EOF
********************************************************************************
*             PROCEDURA DI IMPORTAZIONE DI UN FILE INI DI mIRC                 *
********************************************************************************
 La procedura di importazione e' terminata, e il menu ${root_menu_name}
dovrebbe automaticamente aggiungersi ad XChat a breve.

 Su ${total_line} linee elaborate ${total_line_imported} importate ($(echo $((${total_line_imported} * 100 / ${total_line})))%).

 E' possibile forzare il ri-caricamento tramite questo comando:

/budus macro ${usermenu_macro_name}

 E' possibile apportare modifiche al file importato sia modificando il file INI
originale (${file_ini_path}) - chiaramente bisognera' ripetere
l'importazione -, oppure, modificando con qualsiasi editor di testo il file
${usermenu_macro_path} .
********************************************************************************
PREMI INVIO PER TERMINARE ...
EOF
    [ ${flag_skip_user_question:-0} == 0 ] && read
fi

################################################################################
#_______________________________________________________________________________